Subject: Re: [MSEC] Key Management protocol (GDOI - 6407) forward

From: Brian Weis <[email-masked]>
Date: Fri, 11 Oct 2013 17:10:50 -0700

Hi Paul,

On Sep 27, 2013, at 2:52 PM, Paul Lambert <[email-masked]> wrote:

> 
>> IEC TC57 WG10 (61850) and IEC TC57 WG15 (Security) has been developing a technology/standard for use as a secure multicast for its use in power grid applications using synchrophasors and other technologies relevant to smartgrid deployments globally.
>>  
>> As part of the effort, some extensions to GDOI were identified.  The 6407 draft incorporates and improves some of the enhancements already identified.  IEC TC57 WG15 is waiting for the draft RFC to transition to an RFC so it can be referenced as a normative standard in IEC 62351-9.
>>  
>> There are several utility vendors and utilities, in particular SCE (Southern California Edison), that are awaiting this transition so that their cyber security frameworks can be updated.  Delays in the transition from draft to RFC will delay implementation of several projects and implementations.
> 
> 
> Good to see such applications.  

Thanks for your encouragement.

> What encapsulation mode is specified for this multicast service?   Just curious since I have other industry requirements that are very similar and need better multicast security.

The data transports are defined in the IEC 61850-90 family of standards, and are a part of the frame formats used within and between power substations. I don't think they is generally re-usable to other industries.

But some of the payloads defined in this Internet-Draft might be applicable for key management in other industries. In particular the OID Identification (ID) payload could be used by any protocol using an OID as an identity.

Thanks,
Brian

> 
> Thanks in advance,
> 
> Paul
> 
> 
>>  
>>  
>>  
>>  
>>  
>> Herbert Falk
>> Solutions Architect
>> SISCO, INC.
>> 6605 19 1Ž2 Mile Rd.
>> Sterling Heights, MI 48314
>> (586) 254-0020 x-105
>> 
>>  
>>                                                                               
>> "In matters of style, swim with the current;   in matters of principle, stand like a rock." [Thomas Jefferson]
>>  
>>  
>> NOTICE: This communication may contain privileged or other confidential information. If you are not the intended recipient, or believe that you have  received this communication in error, please do not print, copy, retransmit,  disseminate, or otherwise use the information. Also,  please indicate to the sender that you have received this communication in error, and delete the copy you received. Thank you.
>>  
> 
> 
> 
> _______________________________________________
> MSEC mailing list
> [email-masked]
> https://www.ietf.org/mailman/listinfo/msec

-- 
Brian Weis
Security, Enterprise Networking Group, Cisco Systems
Telephone: +1 408 526 4796
Email: [email-masked]

---

From: Paul Lambert <[email-masked]>
Date: Mon, 14 Oct 2013 18:10:28 -0700

Brian,

Thanks for the info …

In MSEC or the 61850 series I do not see how the group key distribution handles the issues of nonce/key uniqueness for algorithm modes like CCM or GCM.  I'd assumed that this multicast group would need to address this very important security requirement.

I'm sure it must just be my quick read of MSEC that I'm missing something, but  … How does the MSEC or 61850 protocols handle the limitations of AES-CCM or AES-GCM and provide a guarantee of transmitted nonce/key uniqueness for multicast groups?

I was hoping to find in the MSEC a new algorithm mode (which I believe is the preferred answer to the issue) or perhaps another mechanism.   The Wi-Fi multicast security solutions currently require N squared messages to give each device it's own group key because of the nonce/key uniqueness requirement.  This is a limitation (IMO) of CCM and GCM.  IN some environments or protocols it might be possible to coordinate or control the nonce to make sure it is not repeated for a group of devices.  This is quite difficult for consumer device since if reset they would forget state and potentially repeat a nonce (unless some device coordinates nonce usage – impossible in ad hoc environments).

Regards,

Paul

Thanks,
Brian

Thanks in advance,

Paul

Herbert Falk
Solutions Architect
SISCO, INC.
6605 19 1Ž2 Mile Rd.

________________________________

_______________________________________________
MSEC mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/msec

--
Brian Weis
Security, Enterprise Networking Group, Cisco Systems
Telephone: +1 408 526 4796
Email: [email-masked]<mailto:[email-masked]>

---

From: Brian Weis <[email-masked]>
Date: Tue, 15 Oct 2013 09:40:50 -0700

Hi Paul,

> I'm sure it must just be my quick read of MSEC that I'm missing something, but  … How does the MSEC or 61850 protocols handle the limitations of AES-CCM or AES-GCM and provide a guarantee of transm…

You're right, this is very important. You can find a general description of the MSEC solution in RFC 6054 <http://tools.ietf.org/html/rfc6054>. Briefly, the Nonce space is segmented so that each group members has a unique part of the nonce space. The GDOI protocol supports this in RFC 6407 by distributing unique upper bits of the nonce (SID).

> I was hoping to find in the MSEC a new algorithm mode (which I believe is the preferred answer to the issue) or perhaps another mechanism.   The Wi-Fi multicast security solutions currently require…

The MSEC protocols all assume a centralized key management service, which carefully allocates the SIDs. As you say, in order to repeat the devices have to request an SID after a reset but they also have to request the rest of the keying state as well.  The controller always returns a new SID to ensure the old nonces are not reused. Another system using a centralized controller could likely do something similar.

Hope that helps,
Brian

---

From: Paul Lambert <[email-masked]>
Date: Tue, 15 Oct 2013 19:50:04 -0700

Brian,

Thanks for the help below.  It's a bit confusing trying to find how the SID is set, but I'll keep keep looking.

Are there any reference implementations of test vectors for MSEC?

Paul

Hi Paul,

On Oct 14, 2013, at 6:10 PM, Paul Lambert <[email-masked]<mailto:[email-masked]>> wrote:

Brian,

Thanks for the info …

Hope that helps,
Brian

Regards,

Paul

Thanks,
Brian

Thanks in advance,

Paul

Herbert Falk
Solutions Architect
SISCO, INC.
6605 19 1Ž2 Mile Rd.

---

From: Brian Weis <[email-masked]>
Date: Tue, 15 Oct 2013 21:15:24 -0700

Hi Paul,

> Thanks for the help below.  It's a bit confusing trying to find how the SID is set, but I'll keep keep looking.

Section 3.5 of RFC 6407 gives an overview of the key server (KS) operations that guarantee uniqueness of the SID values. The actual distribution of the SID is done in the KD payload (fourth message in  Figure 2) along with keying material.  See the SID "KD Type" in Section 5.6, further defined in Section 5.6.4. By default the KS will distribute one SID each time a group member "registers" to the KS.

A group member can request more than one SID value if it believes it will need them. For example, if it plans to install the policy in more than one SA Database (SAD) it will need one per SAD). The request is done in the GAP payload sent in message 2 of Figure 2.

> Are there any reference implementations of test vectors for MSEC?

No. Since the GDOI payload is an IKEv1 payload, it is encrypted under a dynamic key and so actual test vectors would be difficult.

Hope that helps,
Brian

---

From: Paul Lambert <[email-masked]>
Date: Wed, 16 Oct 2013 09:05:15 -0700

Brian,

Thanks for the pointer below.  I now see how the SID works in IKE

Yes …  but still possible by showing full computations on both sides.  Not as necessary here since IKEv1 is a well known entity.

Appreciate all the help.  Will see if I can reuse any of the ideas …

Paul

Hope that helps,
Brian

Paul

Hi Paul,

Brian,

Thanks for the info …

Hope that helps,
Brian

Regards,

Paul

Thanks,
Brian

Thanks in advance,

Paul

Herbert Falk
Solutions Architect
SISCO, INC.
6605 19 1Ž2 Mile Rd.